/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/parrotinterpreter.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_parrotinterpreter.h"
#include "pmc_default.h"
#include "parrotinterpreter.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
/* LINE 1 "./src/pmc/parrotinterpreter.pmc" */
/*
Copyright (C) 2001-2011, Parrot Foundation.

=head1 NAME

src/pmc/parrotinterpreter.pmc - Parrot Interpreter

=head1 DESCRIPTION

These are the vtable functions for the ParrotInterpreter base class

   getinterp P0
   set P1, P0[.IGLOBALS_*]  # access interpreter globals
   set I0, P0[x]            # interpinfo I0, x
   set I0, P0[-1]           # get interpreter flags
   set P0[-1], x            # set flags on interpreter
                            # NOTE: this doesn't restart

=head2 Functions

=over 4

=cut

*/

#include "parrot/embed.h"
#include "parrot/dynext.h"
#include "parrot/io.h"
#include "parrot/runcore_api.h"
#include "pmc/pmc_class.h"
#include "pmc/pmc_sub.h"

#define PMC_interp(x) ((Parrot_ParrotInterpreter_attributes *)PMC_data(x))->interp
#define PMC_args(x)   ((Parrot_ParrotInterpreter_attributes *)PMC_data(x))->args
#define PMC_sub(x)    ((Parrot_ParrotInterpreter_attributes *)PMC_data(x))->sub

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

static void create_interp(
    ARGIN(PMC *self),
    ARGIN_NULLOK(Parrot_Interp parent))
        __attribute__nonnull__(1);

#define ASSERT_ARGS_create_interp __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(self))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

/*

=item C<void clone_interpreter(Parrot_Interp d, Parrot_Interp s, INTVAL flags)>

Clones the interpreter as specified by the flags.

=cut

*/

void
clone_interpreter(Parrot_Interp d, Parrot_Interp s, INTVAL flags)
{
    /* we block GC runs while cloning since C<d> is not yet running */
    Parrot_block_GC_mark(d);

    d->scheduler = Parrot_pmc_new(d, enum_class_Scheduler);
    d->scheduler = VTABLE_share_ro(d, d->scheduler);

    /* can't copy directly, unless you want double-frees */
    if (flags & PARROT_CLONE_RUNOPS)
        Parrot_runcore_switch(d, s->run_core->name);

    if (flags & PARROT_CLONE_INTERP_FLAGS) {
        /* XXX setting of IS_THREAD? */
        d->flags       = s->flags;
        d->debug_flags = s->debug_flags;
    }

    if (flags & PARROT_CLONE_HLL) {
        /* we'd like to share the HLL data. Give it a PMC_sync structure
           if it doesn't have one already */
        d->HLL_info = s->HLL_info;
        Parrot_hll_regenerate_HLL_namespaces(d);
    }

    if (flags & (PARROT_CLONE_LIBRARIES | PARROT_CLONE_CLASSES)) {
        INTVAL i, last_remove;
        const INTVAL start = d->n_vtable_max;

        /* copy type registrations to keep type numbers the same */
        d->class_hash   = Parrot_clone(d, s->class_hash);
        d->n_vtable_max = s->n_vtable_max;

        if (d->n_vtable_max > d->n_vtable_alloced)
            Parrot_vtbl_realloc_vtables(d);

        last_remove = s->n_vtable_max;

        for (i = s->n_vtable_max - 1; i >= start; --i) {
            if (s->vtables[i] && s->vtables[i]->pmc_class &&
                PObj_is_class_TEST(s->vtables[i]->pmc_class)) {
                STRING * const class_name =
                    VTABLE_get_string(s, s->vtables[i]->pmc_class);
                PARROT_ASSERT(VTABLE_exists_keyed_str(d,
                    d->class_hash, class_name));

                VTABLE_delete_keyed_str(d, d->class_hash, class_name);

                if (last_remove == i + 1) {
                    --d->n_vtable_max;
                    last_remove = i;
                }
            }
        }
    }

    if (flags & PARROT_CLONE_LIBRARIES) {
        PMC   * const libs     = VTABLE_get_pmc_keyed_int(s, s->iglobals,
            IGLOBALS_DYN_LIBS);
        PMC   * const lib_iter = VTABLE_get_iter(s, libs);
        const INTVAL n         = VTABLE_elements(s, libs);
        INTVAL i;

        for (i = 0; i < n; ++i) {
            STRING * const key     = VTABLE_shift_string(s, lib_iter);
            PMC    * const lib_pmc = VTABLE_get_pmc_keyed_str(s, libs, key);
            PMC    * const ignored = Parrot_dyn_clone_lib_into(d, s, lib_pmc);
            UNUSED(ignored);
        }
    }

    if (flags & PARROT_CLONE_CLASSES) {
        INTVAL i;
        for (i = 0; i < s->n_vtable_max; ++i) {
            if (s->vtables[i] && s->vtables[i]->pmc_class &&
                    PObj_is_class_TEST(s->vtables[i]->pmc_class)) {
                /* Cloning the class into the new interpreter ought
                 * to be sufficient to instantiate the class.  */
                PMC                     * const source       = s->vtables[i]->pmc_class;
                PMC                     * const dest         = Parrot_clone(d, source);
                Parrot_Class_attributes * const source_class = PARROT_CLASS(source);
                Parrot_Class_attributes * const dest_class   = PARROT_CLASS(dest);

                dest_class->name           = source_class->name;
                dest_class->_namespace     = VTABLE_clone(d, source_class->_namespace);
            }
        }
    }

    if (flags & PARROT_CLONE_CODE)
        pt_clone_code(d, s);

    if (flags & PARROT_CLONE_GLOBALS)
        pt_clone_globals(d, s);

    Parrot_unblock_GC_mark(d);
}


/*

=item C<static void create_interp(PMC *self, Parrot_Interp parent)>

Creates a new child interpreter of C<parent>.

=cut

*/

static void
create_interp(ARGIN(PMC *self), ARGIN_NULLOK(Parrot_Interp parent))
{
    ASSERT_ARGS(create_interp)
    Interp_flags flag  = PARROT_NO_FLAGS;
    Parrot_Interp new_interp;

    if (self->vtable->base_type == enum_class_ParrotThread)
        flag = PARROT_IS_THREAD;

    new_interp       = make_interpreter(parent, (INTVAL)flag);
    PMC_interp(self) = new_interp;

    VTABLE_set_pmc_keyed_int(new_interp, new_interp->iglobals,
        (INTVAL) IGLOBALS_INTERPRETER, self);

    new_interp->current_cont = NEED_CONTINUATION;
}
/* LINE 213 "./src/pmc/parrotinterpreter.c" */
static  PMC  * Parrot_ParrotInterpreter_clone(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ParrotInterpreter_destroy(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ParrotInterpreter_freeze(PARROT_INTERP, ARGMOD(PMC *_self), PMC *info);
static  INTVAL  Parrot_ParrotInterpreter_get_integer(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_ParrotInterpreter_get_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  PMC  * Parrot_ParrotInterpreter_get_pmc(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_ParrotInterpreter_get_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  PMC  * Parrot_ParrotInterpreter_get_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  void  * Parrot_ParrotInterpreter_get_pointer(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ParrotInterpreter_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ParrotInterpreter_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *parent);
static  opcode_t  * Parrot_ParrotInterpreter_invoke(PARROT_INTERP, ARGMOD(PMC *_self), void *next);
static  INTVAL Parrot_ParrotInterpreter_is_equal(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_ParrotInterpreter_set_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, INTVAL val);
static  void  Parrot_ParrotInterpreter_set_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *args);
static  void  Parrot_ParrotInterpreter_set_pointer(PARROT_INTERP, ARGMOD(PMC *_self), void *value);
static  void Parrot_ParrotInterpreter_nci_yield(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ParrotInterpreter_nci_recursion_limit(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_ParrotInterpreter_multi_is_equal_ParrotInterpreter(PARROT_INTERP, ARGMOD(PMC *_self), PMC *val);
static  INTVAL  Parrot_ParrotInterpreter_multi_is_equal_ParrotThread(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_ParrotInterpreter_multi_is_equal_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void Parrot_ParrotInterpreter_nci_run_gc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ParrotInterpreter_nci_hll_map(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ParrotInterpreter_nci_stdin_handle(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ParrotInterpreter_nci_stdout_handle(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ParrotInterpreter_nci_stderr_handle(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ParrotInterpreter_nci_getpid(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ParrotInterpreter_init_orig(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ParrotInterpreter_init_pmc_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *parent);
static  void  Parrot_ParrotInterpreter_set_integer_keyed_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, INTVAL val);
static  void  Parrot_ParrotInterpreter_set_pmc_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *args);
static  void  Parrot_ParrotInterpreter_set_pointer_orig(PARROT_INTERP, ARGMOD(PMC *_self), void *value);
static  void Parrot_ParrotInterpreter_multi_is_equal_ParrotInterpreter_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ParrotInterpreter_multi_is_equal_ParrotThread_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ParrotInterpreter_multi_is_equal_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
void    Parrot_ParrotInterpreter_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ParrotInterpreter_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ParrotInterpreter_get_vtable(PARROT_INTERP);
void    Parrot_ParrotInterpreter_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ParrotInterpreter_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ParrotInterpreter_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_ParrotInterpreter_clone(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 622 "./src/pmc/parrotinterpreter.pmc" */

    PMC * const dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    clone_interpreter(PMC_interp(dest),
                      PMC_interp(_self), PARROT_CLONE_DEFAULT);

    return dest;
/* LINE 266 "./src/pmc/parrotinterpreter.c" */
}
static  void 
Parrot_ParrotInterpreter_destroy(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 294 "./src/pmc/parrotinterpreter.pmc" */

    if (PMC_data(_self)) {
        mem_gc_free(interp, PMC_data(_self));
        PMC_data(_self) = NULL;
    }
/* LINE 277 "./src/pmc/parrotinterpreter.c" */
}
static  void 
Parrot_ParrotInterpreter_freeze(PARROT_INTERP, ARGMOD(PMC *_self), PMC *info)
{
/* LINE 701 "./src/pmc/parrotinterpreter.pmc" */

    Parrot_ex_throw_from_c_args(interp, NULL, 0,
            "Attempt to freeze interpreter");
/* LINE 286 "./src/pmc/parrotinterpreter.c" */
}
static  INTVAL 
Parrot_ParrotInterpreter_get_integer(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 350 "./src/pmc/parrotinterpreter.pmc" */

    const Parrot_Interp i = PMC_interp(_self);
    if (i->thread_data)
      return (INTVAL)i->thread_data->tid;
    return 0;
/* LINE 297 "./src/pmc/parrotinterpreter.c" */
}
static  INTVAL 
Parrot_ParrotInterpreter_get_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
/* LINE 578 "./src/pmc/parrotinterpreter.pmc" */

    Interp * const new_interp = PMC_interp(_self);

    if (key == -1)
        return (INTVAL)new_interp->flags;

    return interpinfo(new_interp, key);
/* LINE 310 "./src/pmc/parrotinterpreter.c" */
}
static  PMC  *
Parrot_ParrotInterpreter_get_pmc(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 393 "./src/pmc/parrotinterpreter.pmc" */

    return PMC_args(_self);
/* LINE 318 "./src/pmc/parrotinterpreter.c" */
}
static  PMC  *
Parrot_ParrotInterpreter_get_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
/* LINE 460 "./src/pmc/parrotinterpreter.pmc" */

    PMC    *nextkey;
    STRING *outer = NULL;
    STRING *item  = Parrot_key_string(interp, key);
    int     level = 0;

    PMC *ctx;

    if (STRING_equal(interp, item, CONST_STRING(interp, "globals")))
        return interp->root_namespace;

    if (STRING_equal(interp, item, CONST_STRING(interp, "packfile")))
        return Parrot_pf_get_current_packfile(interp);

    if (STRING_equal(interp, item, CONST_STRING(interp, "outer"))) {
        outer   = item;
        nextkey = Parrot_key_next(interp, key);

        if (nextkey && (PObj_get_FLAGS(nextkey) & KEY_string_FLAG)) {
            key  = nextkey;
            item = VTABLE_get_string(interp, key);
        }
    }

    nextkey = Parrot_key_next(interp, key);

    if (nextkey)
        level = VTABLE_get_integer(interp, nextkey);
    else if (outer)
        level = 1;

    if (level < 0)
        Parrot_ex_throw_from_c_args(interp, NULL, CONTROL_ERROR,
            "No such caller depth");

    ctx = CURRENT_CONTEXT(interp);

    if (outer) {
        for (; level; --level) {
            ctx = Parrot_pcc_get_outer_ctx(interp, ctx);
            if (PMC_IS_NULL(ctx))
                Parrot_ex_throw_from_c_args(interp, NULL,
                    CONTROL_ERROR, "No such outer depth");
        }
    }
    else {
        for (; level; --level) {
            PMC * const cont = Parrot_pcc_get_continuation(interp, ctx);

            if (PMC_IS_NULL(cont) || !PARROT_CONTINUATION(cont)->seg)
                Parrot_ex_throw_from_c_args(interp, NULL,
                    CONTROL_ERROR, "No such caller depth");

            ctx = PARROT_CONTINUATION(cont)->to_ctx;

            if (PMC_IS_NULL(Parrot_pcc_get_sub(interp, ctx)))
                Parrot_ex_throw_from_c_args(interp, NULL,
                    CONTROL_ERROR, "No such caller depth");
        }
    }

    if (item == outer)
        return Parrot_pcc_get_sub(interp, ctx);

    if (STRING_equal(interp, item, CONST_STRING(interp, "context")))
        return ctx;

    if (STRING_equal(interp, item, CONST_STRING(interp, "sub")))
        return Parrot_pcc_get_sub(interp, ctx);

    if (STRING_equal(interp, item, CONST_STRING(interp, "lexpad")))
        return Parrot_pcc_get_lex_pad(interp, ctx);

    if (STRING_equal(interp, item, CONST_STRING(interp, "namespace")))
        return Parrot_pcc_get_namespace(interp, ctx);

    if (STRING_equal(interp, item, CONST_STRING(interp, "continuation")))
        return VTABLE_clone(interp, Parrot_pcc_get_continuation(interp, ctx));

    if (STRING_equal(interp, item, CONST_STRING(interp, "annotations"))) {
        PMC * const sub_pmc = Parrot_pcc_get_sub(interp, ctx);
        if (ctx == CURRENT_CONTEXT(interp)) {
            /* We can't know the current program counter for the currently
             * executing sub, so can't return annotations for that. */
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                    "Cannot get annotations at depth 0; use annotations op instead.");
        }
        if (!PMC_IS_NULL(sub_pmc)
        &&   sub_pmc->vtable->base_type == enum_class_Sub) {
            Parrot_Sub_attributes *sub;
            PackFile_ByteCode     *seg;
            opcode_t * const pc = Parrot_pcc_get_pc(interp, ctx);

            PMC_get_sub(interp, sub_pmc, sub);
            seg = sub->seg;

            if (sub->seg->annotations)
                return PackFile_Annotations_lookup(interp, seg->annotations,
                    pc - seg->base.data, NULL);
        }

        return Parrot_pmc_new(interp, enum_class_Hash);
    }

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ATTRIB_NOT_FOUND,
            "No such item %Ss", item);
/* LINE 430 "./src/pmc/parrotinterpreter.c" */
}
static  PMC  *
Parrot_ParrotInterpreter_get_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
/* LINE 422 "./src/pmc/parrotinterpreter.pmc" */

    Interp * const new_interp = PMC_interp(_self);

    if (key >= 0 && key < IGLOBALS_SIZE) {
        PMC * const val = VTABLE_get_pmc_keyed_int(new_interp,
                new_interp->iglobals, key);
        return val == NULL ? PMCNULL : val;
    }

    /* quick hack to get the global stash */
    if (key == -1)
        return new_interp->root_namespace;

    return PMCNULL;
/* LINE 450 "./src/pmc/parrotinterpreter.c" */
}
static  void  *
Parrot_ParrotInterpreter_get_pointer(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 336 "./src/pmc/parrotinterpreter.pmc" */

    return PMC_interp(_self);
/* LINE 458 "./src/pmc/parrotinterpreter.c" */
}
static  void 
Parrot_ParrotInterpreter_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
Parrot_ParrotInterpreter_init_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_ParrotInterpreter_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *parent)
{
Parrot_ParrotInterpreter_init_pmc_orig(interp, _self, parent);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  opcode_t  *
Parrot_ParrotInterpreter_invoke(PARROT_INTERP, ARGMOD(PMC *_self), void *next)
{
/* LINE 367 "./src/pmc/parrotinterpreter.pmc" */

    Interp * const new_interp = PMC_interp(_self);

    /* setup code */
    pt_thread_prepare_for_run(new_interp, interp);

    /* TODO pass arguments from parent (interp) to child (new_interp) by
     * possibly clone of share the arguments r/o args can be passed as is */

    /* calculate offset and run */
    runops(new_interp, (size_t)((opcode_t *)PMC_sub(_self) -
        (opcode_t *)interp->code->base.data));

    return (opcode_t *)next;
/* LINE 490 "./src/pmc/parrotinterpreter.c" */
}
static  INTVAL
Parrot_ParrotInterpreter_is_equal(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_ParrotInterpreter:
            return Parrot_ParrotInterpreter_multi_is_equal_ParrotInterpreter(interp, _self, value);
            break;
        case enum_class_ParrotThread:
            return Parrot_ParrotInterpreter_multi_is_equal_ParrotThread(interp, _self, value);
            break;
        case enum_class_core_max:
            {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "is_equal", "PP->I", _self, value, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_ParrotInterpreter_multi_is_equal_DEFAULT(interp, _self, value);
            break;

    }
}
static  void 
Parrot_ParrotInterpreter_set_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, INTVAL val)
{
Parrot_ParrotInterpreter_set_integer_keyed_int_orig(interp, _self, key, val);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_ParrotInterpreter_set_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *args)
{
Parrot_ParrotInterpreter_set_pmc_orig(interp, _self, args);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_ParrotInterpreter_set_pointer(PARROT_INTERP, ARGMOD(PMC *_self), void *value)
{
Parrot_ParrotInterpreter_set_pointer_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void
Parrot_ParrotInterpreter_nci_yield(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 364 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
/* LINE 545 "./src/pmc/parrotinterpreter.pmc" */

/* LINE 372 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
/* LINE 376 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    { /* BEGIN PMETHOD BODY */
/* LINE 218 "./src/pmc/parrotinterpreter.pmc" */

    pt_thread_yield();
/* LINE 386 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
/* LINE 563 "./src/pmc/parrotinterpreter.c" */
}
static  void
Parrot_ParrotInterpreter_nci_recursion_limit(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 364 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
/* LINE 573 "./src/pmc/parrotinterpreter.pmc" */
INTVAL l;
INTVAL has_l;

/* LINE 372 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiIoIp",
            &_self, &l, &has_l);
/* LINE 376 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    { /* BEGIN PMETHOD BODY */
/* LINE 222 "./src/pmc/parrotinterpreter.pmc" */

    const INTVAL ret = interp->recursion_limit;
    if (has_l)
        interp->recursion_limit = l;
    /* LINE 209 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    {
    /*BEGIN RETURN INTVAL ret */
/* LINE 217 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "I", (INTVAL)ret);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL ret */
    }
/* LINE 226 "./src/pmc/parrotinterpreter.pmc" */

/* LINE 386 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
/* LINE 607 "./src/pmc/parrotinterpreter.c" */
}
static  INTVAL 
Parrot_ParrotInterpreter_multi_is_equal_ParrotInterpreter(PARROT_INTERP, ARGMOD(PMC *_self), PMC *val)
{
/* LINE 644 "./src/pmc/parrotinterpreter.pmc" */

    Parrot_Interp self  = PMC_interp(_self);
    Parrot_Interp other = PMC_interp(val);

    if (!self->thread_data && !other->thread_data)
        return 1;

    if (self->thread_data && other->thread_data &&
        self->thread_data->tid == other->thread_data->tid)
        return 1;

    return 0;
/* LINE 625 "./src/pmc/parrotinterpreter.c" */
}
static  INTVAL 
Parrot_ParrotInterpreter_multi_is_equal_ParrotThread(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
/* LINE 658 "./src/pmc/parrotinterpreter.pmc" */

    Parrot_Interp self  = PMC_interp(_self);

    if (!self->thread_data)
        return 0;

    return self->thread_data->tid == (UINTVAL) VTABLE_get_integer(interp, value);
/* LINE 638 "./src/pmc/parrotinterpreter.c" */
}
static  INTVAL 
Parrot_ParrotInterpreter_multi_is_equal_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
/* LINE 667 "./src/pmc/parrotinterpreter.pmc" */

    Parrot_ex_throw_from_c_args(interp, NULL,
            EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
            "ParrotInterpreter: no multiple dispatch variant 'is_equal' for %Ss",
            VTABLE_name(interp, value));
/* LINE 649 "./src/pmc/parrotinterpreter.c" */
}
static  void
Parrot_ParrotInterpreter_nci_run_gc(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 364 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
/* LINE 659 "./src/pmc/parrotinterpreter.pmc" */

/* LINE 372 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
/* LINE 376 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    { /* BEGIN PMETHOD BODY */
/* LINE 706 "./src/pmc/parrotinterpreter.pmc" */

    Parrot_gc_mark_and_sweep(PMC_interp(_self), 0);
/* LINE 386 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
/* LINE 677 "./src/pmc/parrotinterpreter.c" */
}
static  void
Parrot_ParrotInterpreter_nci_hll_map(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 364 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
/* LINE 687 "./src/pmc/parrotinterpreter.pmc" */
PMC* core_type;
PMC* hll_type;

/* LINE 372 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiPP",
            &_self, &core_type, &hll_type);
/* LINE 376 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    { /* BEGIN PMETHOD BODY */
/* LINE 720 "./src/pmc/parrotinterpreter.pmc" */

    const INTVAL core_type_id = VTABLE_type(interp, core_type);
    const INTVAL hll_type_id  = VTABLE_type(interp, hll_type);
    const INTVAL hll_id       = Parrot_pcc_get_HLL(interp, CURRENT_CONTEXT(interp));
    Parrot_hll_register_HLL_type(interp, hll_id, core_type_id, hll_type_id);
/* LINE 386 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
/* LINE 710 "./src/pmc/parrotinterpreter.c" */
}
static  void
Parrot_ParrotInterpreter_nci_stdin_handle(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 364 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
/* LINE 720 "./src/pmc/parrotinterpreter.pmc" */
PMC* newhandle;

/* LINE 372 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiPo",
            &_self, &newhandle);
/* LINE 376 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    { /* BEGIN PMETHOD BODY */
/* LINE 740 "./src/pmc/parrotinterpreter.pmc" */

    PMC * const handle = Parrot_io_stdhandle(interp, PIO_STDIN_FILENO, newhandle);
    /* LINE 209 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    {
    /*BEGIN RETURN PMC *handle */
/* LINE 217 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)handle);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *handle */
    }
/* LINE 742 "./src/pmc/parrotinterpreter.pmc" */

/* LINE 386 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
/* LINE 751 "./src/pmc/parrotinterpreter.c" */
}
static  void
Parrot_ParrotInterpreter_nci_stdout_handle(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 364 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
/* LINE 761 "./src/pmc/parrotinterpreter.pmc" */
PMC* newhandle;

/* LINE 372 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiPo",
            &_self, &newhandle);
/* LINE 376 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    { /* BEGIN PMETHOD BODY */
/* LINE 758 "./src/pmc/parrotinterpreter.pmc" */

    PMC * const handle = Parrot_io_stdhandle(interp, PIO_STDOUT_FILENO, newhandle);
    /* LINE 209 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    {
    /*BEGIN RETURN PMC *handle */
/* LINE 217 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)handle);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *handle */
    }
/* LINE 760 "./src/pmc/parrotinterpreter.pmc" */

/* LINE 386 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
/* LINE 792 "./src/pmc/parrotinterpreter.c" */
}
static  void
Parrot_ParrotInterpreter_nci_stderr_handle(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 364 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
/* LINE 802 "./src/pmc/parrotinterpreter.pmc" */
PMC* newhandle;

/* LINE 372 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiPo",
            &_self, &newhandle);
/* LINE 376 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    { /* BEGIN PMETHOD BODY */
/* LINE 776 "./src/pmc/parrotinterpreter.pmc" */

    PMC * const handle = Parrot_io_stdhandle(interp, PIO_STDERR_FILENO, newhandle);
    /* LINE 209 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    {
    /*BEGIN RETURN PMC *handle */
/* LINE 217 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)handle);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *handle */
    }
/* LINE 778 "./src/pmc/parrotinterpreter.pmc" */

/* LINE 386 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
/* LINE 833 "./src/pmc/parrotinterpreter.c" */
}
static  void
Parrot_ParrotInterpreter_nci_getpid(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 364 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
/* LINE 843 "./src/pmc/parrotinterpreter.pmc" */

/* LINE 372 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
/* LINE 376 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    { /* BEGIN PMETHOD BODY */
/* LINE 792 "./src/pmc/parrotinterpreter.pmc" */

    const INTVAL id = Parrot_getpid();
    /* LINE 209 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    {
    /*BEGIN RETURN INTVAL id */
/* LINE 217 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "I", (INTVAL)id);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL id */
    }
/* LINE 794 "./src/pmc/parrotinterpreter.pmc" */

/* LINE 386 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
/* LINE 873 "./src/pmc/parrotinterpreter.c" */
}
static  void 
Parrot_ParrotInterpreter_init_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 239 "./src/pmc/parrotinterpreter.pmc" */

    /*
     * init/init_pmc may be called internally (from thread creation in
     * ParrotThread::init_pmc() or stand-alone
     * so we check, if the interpreter is already set up
     */
    if (!PMC_data(_self)) {
        Parrot_ParrotInterpreter_attributes * const attrs =
            mem_gc_allocate_zeroed_typed(interp, Parrot_ParrotInterpreter_attributes);
        PMC_data(_self) = attrs;
    }
    if (!PMC_interp(_self)) {
        create_interp(_self, interp);
    }
    PObj_custom_destroy_SET(_self);
/* LINE 894 "./src/pmc/parrotinterpreter.c" */
}
static  void 
Parrot_ParrotInterpreter_init_pmc_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *parent)
{
/* LINE 268 "./src/pmc/parrotinterpreter.pmc" */

    /* XXX Can this be moved inside the block where it's used */
    Parrot_Interp p = PMC_interp(parent);

    if (!PMC_data(_self)) {
        Parrot_ParrotInterpreter_attributes * const attrs =
            mem_gc_allocate_zeroed_typed(interp, Parrot_ParrotInterpreter_attributes);
        PMC_data(_self) = attrs;
    }
    if (!PMC_interp(_self)) {
        create_interp(_self, p);
    }
    PObj_custom_destroy_SET(_self);
/* LINE 913 "./src/pmc/parrotinterpreter.c" */
}
static  void 
Parrot_ParrotInterpreter_set_integer_keyed_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, INTVAL val)
{
/* LINE 597 "./src/pmc/parrotinterpreter.pmc" */

    Interp * const new_interp = PMC_interp(_self);

    /* set interpreter flags */
    if (key == -1) {
        const INTVAL allowed = PARROT_BOUNDS_FLAG | PARROT_PROFILE_FLAG |
                         PARROT_GC_DEBUG_FLAG;
        Parrot_clear_flag(new_interp, allowed);
        Parrot_set_flag(new_interp, val & allowed);
    }
/* LINE 929 "./src/pmc/parrotinterpreter.c" */
}
static  void 
Parrot_ParrotInterpreter_set_pmc_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *args)
{
/* LINE 407 "./src/pmc/parrotinterpreter.pmc" */

    PMC_args(_self) = args;
/* LINE 937 "./src/pmc/parrotinterpreter.c" */
}
static  void 
Parrot_ParrotInterpreter_set_pointer_orig(PARROT_INTERP, ARGMOD(PMC *_self), void *value)
{
/* LINE 312 "./src/pmc/parrotinterpreter.pmc" */


    /* XXX: init_world in src/global_setup.c needs to create a
     * ParrotInterpreter through Parrot_pmc_new_noinit.  If this PMC hasn't been
     * initialized, cheat by initializing instead. */
    if (!PMC_data(_self)) {
        Parrot_ParrotInterpreter_attributes * const attrs =
            mem_gc_allocate_zeroed_typed(interp, Parrot_ParrotInterpreter_attributes);
        PMC_data(_self) = attrs;
        PObj_custom_destroy_SET(_self);
    }
    PMC_interp(_self) = (struct parrot_interp_t *)value;
/* LINE 955 "./src/pmc/parrotinterpreter.c" */
}
static  void
Parrot_ParrotInterpreter_multi_is_equal_ParrotInterpreter_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *val;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &val);
_result = Parrot_ParrotInterpreter_multi_is_equal_ParrotInterpreter(interp, _self, val);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
static  void
Parrot_ParrotInterpreter_multi_is_equal_ParrotThread_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_ParrotInterpreter_multi_is_equal_ParrotThread(interp, _self, value);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
static  void
Parrot_ParrotInterpreter_multi_is_equal_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_ParrotInterpreter_multi_is_equal_DEFAULT(interp, _self, value);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_ParrotInterpreter_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_ParrotInterpreter_clone;
    vt->destroy = Parrot_ParrotInterpreter_destroy;
    vt->freeze = Parrot_ParrotInterpreter_freeze;
    vt->get_integer = Parrot_ParrotInterpreter_get_integer;
    vt->get_integer_keyed_int = Parrot_ParrotInterpreter_get_integer_keyed_int;
    vt->get_pmc = Parrot_ParrotInterpreter_get_pmc;
    vt->get_pmc_keyed = Parrot_ParrotInterpreter_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_ParrotInterpreter_get_pmc_keyed_int;
    vt->get_pointer = Parrot_ParrotInterpreter_get_pointer;
    vt->init = Parrot_ParrotInterpreter_init;
    vt->init_pmc = Parrot_ParrotInterpreter_init_pmc;
    vt->invoke = Parrot_ParrotInterpreter_invoke;
    vt->is_equal = Parrot_ParrotInterpreter_is_equal;
    vt->set_integer_keyed_int = Parrot_ParrotInterpreter_set_integer_keyed_int;
    vt->set_pmc = Parrot_ParrotInterpreter_set_pmc;
    vt->set_pointer = Parrot_ParrotInterpreter_set_pointer;
    vt->attr_size = 0;

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_ParrotInterpreter_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_ParrotInterpreter_clone;
    vt->destroy = Parrot_ParrotInterpreter_destroy;
    vt->freeze = Parrot_ParrotInterpreter_freeze;
    vt->get_integer = Parrot_ParrotInterpreter_get_integer;
    vt->get_integer_keyed_int = Parrot_ParrotInterpreter_get_integer_keyed_int;
    vt->get_pmc = Parrot_ParrotInterpreter_get_pmc;
    vt->get_pmc_keyed = Parrot_ParrotInterpreter_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_ParrotInterpreter_get_pmc_keyed_int;
    vt->get_pointer = Parrot_ParrotInterpreter_get_pointer;
    vt->invoke = Parrot_ParrotInterpreter_invoke;
    vt->is_equal = Parrot_ParrotInterpreter_is_equal;
    vt->attr_size = 0;

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ParrotInterpreter_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_ParrotInterpreter_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ParrotInterpreter_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_ParrotInterpreter_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_ParrotInterpreter_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        Parrot_str_new_init(interp, "ParrotInterpreter", 17,
            Parrot_default_encoding_ptr, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_ParrotInterpreter_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "ParrotInterpreter")), PMCNULL);
    return isa;
}

void
Parrot_ParrotInterpreter_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":interp Itid Fargs Fsub ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_ParrotInterpreter_get_vtable(interp);
        vt->base_type      = enum_class_ParrotInterpreter;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "ParrotInterpreter");
        vt->provides_str = CONST_STRING_GEN(interp, "invokable");
        vt->isa_hash     = Parrot_ParrotInterpreter_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_ParrotInterpreter_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_ParrotInterpreter;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_ParrotInterpreter_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "yield");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ParrotInterpreter_nci_yield),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "recursion_limit");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ParrotInterpreter_nci_recursion_limit),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "run_gc");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ParrotInterpreter_nci_run_gc),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "hll_map");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ParrotInterpreter_nci_hll_map),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "stdin_handle");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ParrotInterpreter_nci_stdin_handle),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "stdout_handle");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ParrotInterpreter_nci_stdout_handle),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "stderr_handle");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ParrotInterpreter_nci_stderr_handle),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "getpid");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ParrotInterpreter_nci_getpid),
                method_name, signature);
        }
        {
            STRING * const mfl_0 = CONST_STRING_GEN(interp, "is_equal");
            STRING * const mfl_1 = CONST_STRING_GEN(interp, "ParrotInterpreter,ParrotInterpreter");
            STRING * const mfl_2 = CONST_STRING_GEN(interp, "ParrotInterpreter");
            STRING * const mfl_3 = CONST_STRING_GEN(interp, "ParrotInterpreter,ParrotThread");
            STRING * const mfl_4 = CONST_STRING_GEN(interp, "ParrotInterpreter,DEFAULT");
        PMC *_temp_func;
_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_ParrotInterpreter_multi_is_equal_ParrotInterpreter_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_0, mfl_1, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_ParrotInterpreter_multi_is_equal_ParrotThread_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_0, mfl_3, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_ParrotInterpreter_multi_is_equal_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_0, mfl_4, _temp_func);

        }
    } /* pass */
} /* Parrot_ParrotInterpreter_class_init */
/* LINE 796 "./src/pmc/parrotinterpreter.pmc" */


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
